using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Collections;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Drawing;
using Syncfusion.Web.UI.WebControls.Diagram;
using Syncfusion.Windows.Forms.Diagram;

public partial class _Default : System.Web.UI.Page
{
    private DirectedTreeLayoutManager layoutManager = null;
    private Syncfusion.Windows.Forms.Diagram.Rectangle rect = null;
    private Syncfusion.Windows.Forms.Diagram.Ellipse ell = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.IsPostBack == false)
        {
            this.layoutManager = new DirectedTreeLayoutManager(this.DiagramWebControl1.Model, 0, 40, 40);
            this.DiagramWebControl1.LayoutManager = this.layoutManager;
            LoadData("Country");

            // Enable the diagram for user selection and drag and drop
            this.DiagramWebControl1.EnableNodeSelection = true;
            this.DiagramWebControl1.EnableDragDrop = true;
        }
        this.DiagramWebControl1.RenderImageMap = true;

    }
    private void LoadData(string tablename)
    {

        string datasrcpath = Server.MapPath(String.Empty);
        datasrcpath = datasrcpath + @"\App_Data\Country.mdb";

        // Connection string for the Org.mdb Access database
        string connectionstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + datasrcpath + ";";
        OleDbConnection orgdbconnection = new OleDbConnection(connectionstring);
        // Query to select all records from the Org.mbd database
        string orgdbselectquery = "SELECT * FROM " + tablename;
        //CreateMajorSymbols(tablename);
        OleDbCommand orgdbcommand = new OleDbCommand(orgdbselectquery, orgdbconnection);
        // Create a connection to the datasource
        orgdbconnection.Open();
        // Execute the query command to build the data reader			
        OleDbDataReader orgdbreader = orgdbcommand.ExecuteReader();

        // Extract employee data from the reader
        while (orgdbreader.Read())
        {
            object[] data=new object[3];
            int count=orgdbreader.GetValues(data);
            string[] st = new string[10];
            string[] str = new string[10];
            for (int i = 0; i < count; i++)
            {
                st[i] = data[i].ToString();
                str[i] = orgdbreader.GetName(i);
            }
            if (tablename == "Country")
            {
                CreateCountryMajorSymbol(st,tablename,str);
            }

        }        // Close the reader
        orgdbreader.Close();
        // Close the connection
        orgdbcommand.Connection.Close();

    }

    private void CreateCountrySymbols(Symbol sym, string st,string str)
    {
        ell = new Ellipse(10, 10, 100, 60);
        Symbol sym1 = new Symbol();
        sym1.AppendChild(ell);
        sym1.AddLabel(str+":"+st, BoxPosition.Center);
        sym1.FillStyle.Color = Color.Violet;
        sym1.FillStyle.ForeColor = Color.White;
        sym1.FillStyle.Type = FillStyleType.LinearGradient;
        InsertNodesCmd ins = new InsertNodesCmd();
        ins.AddNode(sym1, new System.Drawing.PointF(100, 100));
        LinkCmd cmd = new LinkCmd();
        Link link = new Link(Link.Shapes.Line);
        link.AddLabel("Includes", 50);
        cmd.Link = link;
        cmd.SourcePort = sym.CenterPort;
        cmd.TargetPort = sym1.CenterPort;
        cmd.Do(this.DiagramWebControl1.Model);
        ins.Do(this.DiagramWebControl1.Model);
    }

    private void CreateCitySymbols(Symbol sym, string st)
    {
        ell = new Ellipse(10, 10, 100, 60);
        Symbol sym1 = new Symbol();
        sym1.AppendChild(ell);
        sym1.AddLabel(st, BoxPosition.Center);
        sym1.FillStyle.Color = Color.Blue;
        sym1.FillStyle.ForeColor = Color.White;
        sym1.FillStyle.Type = FillStyleType.LinearGradient;
        InsertNodesCmd ins = new InsertNodesCmd();
        ins.AddNode(sym1, new System.Drawing.PointF(100, 100));
        LinkCmd cmd = new LinkCmd();
        Link link = new Link(Link.Shapes.Line);
        cmd.Link = link;
        cmd.SourcePort = sym.CenterPort;
        cmd.TargetPort = sym1.CenterPort;
        cmd.Do(this.DiagramWebControl1.Model);
        ins.Do(this.DiagramWebControl1.Model);


    }
    private void CreateCitizenSymbols(Symbol sym, string st)
    {
        ell = new Ellipse(10, 10, 100, 60);
        Symbol sym1 = new Symbol();
        sym1.AppendChild(ell);
        sym1.AddLabel(st, BoxPosition.Center);
        sym1.FillStyle.Color = Color.DarkOrchid;
        sym1.FillStyle.ForeColor = Color.White;
        sym1.FillStyle.Type = FillStyleType.LinearGradient;
        InsertNodesCmd ins = new InsertNodesCmd();
        ins.AddNode(sym1, new System.Drawing.PointF(100, 100));
        LinkCmd cmd = new LinkCmd();
        Link link = new Link(Link.Shapes.Line);
        cmd.Link = link;
        cmd.SourcePort = sym.CenterPort;
        cmd.TargetPort = sym1.CenterPort;
        cmd.Do(this.DiagramWebControl1.Model);
       
        ins.Do(this.DiagramWebControl1.Model);

    }
    private void CreateCountryMajorSymbol(string [] st,string tablename,string[] str)
    {
        rect = new Syncfusion.Windows.Forms.Diagram.Rectangle(10, 10, 100, 60);
        Symbol sym = new Symbol();
        sym.AppendChild(rect);
        sym.AddLabel(tablename, BoxPosition.Center);      
        sym.FillStyle.Color = Color.Red;
        sym.FillStyle.ForeColor = Color.Yellow;
        sym.FillStyle.Type = FillStyleType.LinearGradient;
        InsertNodesCmd ins = new InsertNodesCmd();
        ins.AddNode(sym, new System.Drawing.PointF(100, 100));
        ins.Do(this.DiagramWebControl1.Model);
        this.DiagramWebControl1.Model.UpdateViews();
        CreateCityMajorSymbol(sym);
        CreateCitizenMajorSymbol(sym);
        CreateCountrySymbols(sym, st[0],str[0]);
        CreateCountrySymbols(sym, st[1],str[1]);       

        this.DiagramWebControl1.LayoutManager.UpdateLayout(null);
        this.DiagramWebControl1.View.Update();
    }

    private void CreateCityMajorSymbol(Symbol sym)
    {
        rect = new Syncfusion.Windows.Forms.Diagram.Rectangle(10, 10, 100, 60);
        Symbol sym1 = new Symbol();
        sym1.AppendChild(rect);
        sym1.AddLabel("Cities", BoxPosition.Center);
        sym1.FillStyle.Color = Color.Red;
        sym1.FillStyle.ForeColor = Color.Yellow;
        sym1.FillStyle.Type = FillStyleType.LinearGradient;
        InsertNodesCmd ins = new InsertNodesCmd();
        ins.AddNode(sym1, new System.Drawing.PointF(100, 100));
        LinkCmd cmd = new LinkCmd();
        Link link = new Link(Link.Shapes.Line);
        link.AddLabel("Includes", 50);
        cmd.Link = link;
        cmd.SourcePort = sym.CenterPort;
        cmd.TargetPort = sym1.CenterPort;
        cmd.Do(this.DiagramWebControl1.Model);
        ins.Do(this.DiagramWebControl1.Model);
        this.DiagramWebControl1.Model.UpdateViews();
        CreateCitySymbols(sym1, "CityName-Chennai");
        CreateCitySymbols(sym1, "Population-one lakh");

    }
    private void CreateCitizenMajorSymbol(Symbol sym)
    {
        rect = new Syncfusion.Windows.Forms.Diagram.Rectangle(10, 10, 100, 40);
        Symbol sym1 = new Symbol();
        sym1.AppendChild(rect);
        sym1.AddLabel("Citizen", BoxPosition.Center);
        sym1.FillStyle.Color = Color.Red;
        sym1.FillStyle.ForeColor = Color.Yellow;
        sym1.FillStyle.Type = FillStyleType.LinearGradient;
        InsertNodesCmd ins = new InsertNodesCmd();
        ins.AddNode(sym1, new System.Drawing.PointF(100, 100));
        LinkCmd cmd = new LinkCmd();
        Link link = new Link(Link.Shapes.Line);
        link.AddLabel("Consists Of", 50);
        cmd.Link = link;
        cmd.SourcePort = sym.CenterPort;
        cmd.TargetPort = sym1.CenterPort;
        cmd.Do(this.DiagramWebControl1.Model);
        ins.Do(this.DiagramWebControl1.Model);
        this.DiagramWebControl1.Model.UpdateViews();
        CreateCitizenSymbols(sym1, "Name:David");
        CreateCitizenSymbols(sym1, "Country:India");  


    }
}